import { NotificationDataRow } from '@genesislcap/foundation-notifications';
import { NotificationListener } from '@genesislcap/foundation-ui';
import { IOConnectDesktop } from '@interopio/desktop';
/**
 * @tagname %%prefix%%-interop-notification-listener
 * @public
 * @remarks
 * This component extends the notification listener class and overrides the logic for showing the toast message to instead dispatch the event to the interop notifications bus.
 */
export declare class InteropNotificationsListener extends NotificationListener {
    iOConnectNotificationOptions: IOConnectDesktop.Notifications.IOConnectNotificationOptions;
    protected showNotificationToast(row: NotificationDataRow): void;
}
/**
 * The Foundation Interop Notification Listener
 *
 * @public
 * @remarks
 * HTML Element: \<foundation-interop-notification-listener\>
 */
export declare const interopFoundationNotificationListener: (overrideDefinition?: import("@microsoft/fast-foundation").OverrideFoundationElementDefinition<{
    baseName: string;
    template: import("@microsoft/fast-element").ViewTemplate<NotificationListener, any>;
    shadowOptions: ShadowRootInit;
}>) => import("@microsoft/fast-foundation").FoundationElementRegistry<{
    baseName: string;
    template: import("@microsoft/fast-element").ViewTemplate<NotificationListener, any>;
    shadowOptions: ShadowRootInit;
}, typeof InteropNotificationsListener>;
//# sourceMappingURL=interop-notifications-listener.d.ts.map