import { __decorate } from "tslib";
import { customElement, FASTElement } from '@genesislcap/web-core';
import { FDC3 } from '../fdc3';
/**
 * fdc3-context-listener listen to channel context
 * @alpha
 */
let Fdc3ContextListener = class Fdc3ContextListener extends FASTElement {
    constructor() {
        super(...arguments);
        this.config = [];
    }
    connectedCallback() {
        super.connectedCallback();
        if (window.fdc3) {
            this.config.forEach((c) => this.fdc3.addChannelListener(null, c.channelType, (message) => {
                if (message.type === c.channelType) {
                    c.callback(message);
                }
            }));
        }
    }
};
__decorate([
    FDC3
], Fdc3ContextListener.prototype, "fdc3", void 0);
Fdc3ContextListener = __decorate([
    customElement({
        name: 'fdc3-context-listener',
    })
], Fdc3ContextListener);
export { Fdc3ContextListener };
