import { __awaiter, __decorate } from "tslib";
import { attr, customElement, FASTElement } from '@genesislcap/web-core';
import { FDC3 } from '../fdc3';
/**
 * fdc3-raise-intent
 * @alpha
 */
let Fdc3RaiseIntent = class Fdc3RaiseIntent extends FASTElement {
    constructor() {
        super(...arguments);
        this.sendEventOnChannel = (e) => __awaiter(this, void 0, void 0, function* () {
            let id = e.data || e.detail;
            if (this.mappingFunction) {
                id = this.mappingFunction(id);
            }
            const context = {
                type: this.intentType,
                id,
            };
            yield this.fdc3.raiseIntent(context, this.intentName);
        });
    }
    connectedCallback() {
        this.parentElement.addEventListener(this.eventName, this.sendEventOnChannel);
    }
    disconnectedCallback() {
        this.parentElement.removeEventListener(this.eventName, this.sendEventOnChannel);
    }
};
__decorate([
    FDC3
], Fdc3RaiseIntent.prototype, "fdc3", void 0);
__decorate([
    attr({ attribute: 'event-name' })
], Fdc3RaiseIntent.prototype, "eventName", void 0);
__decorate([
    attr({ attribute: 'intent-type' })
], Fdc3RaiseIntent.prototype, "intentType", void 0);
__decorate([
    attr({ attribute: 'intent-name' })
], Fdc3RaiseIntent.prototype, "intentName", void 0);
Fdc3RaiseIntent = __decorate([
    customElement({
        name: 'fdc3-raise-intent',
    })
], Fdc3RaiseIntent);
export { Fdc3RaiseIntent };
