import { sinon } from '@genesislcap/foundation-testing';

export const mockFdc3 = () => {
  if (!('fdc3' in window)) {
    const broadcast = sinon.stub();
    const addContextListener = sinon.stub();
    window.fdc3 = {
      broadcast,
      addContextListener,
      getOrCreateChannel: sinon.stub().returns({
        broadcast,
        addContextListener,
      }),
      getInfo: () => ({ fdc3Version: '2.1', provider: 'FINOS' }),
      raiseIntent: sinon.stub(),
      raiseIntentForContext: sinon.stub(),
      addIntentListener: (intent, callback) => {
        return sinon.fake.returns({
          fireIntent: (value) => callback(value),
        });
      },
    };
  }
};

export const removeMockFdc3 = () => {
  if (!('fdc3' in window)) {
    delete window['fdc3'];
  }
};
